Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.instruct
Class CallTemplate

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.CallTemplate

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public class CallTemplate
extends Instruction

Instruction representing an xsl:call-template element in the stylesheet.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`CallTemplate(Template template, WithParam[] actualParams, WithParam[] tunnelParams, boolean useTailRecursion, Expression calledTemplateExpression, NamespaceResolver nsContext)` Construct a CallTemplate instruction.

Method Summary
`Expression` | `analyze(StaticContext env, ItemType contextItemType)` Perform static analysis of an expression and its subexpressions.
`boolean` | `createsNewNodes()` Determine whether this instruction creates new nodes.
`void` | `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic print of expression structure.
`InstructionInfo` | `getInstructionInfo()` Set additional trace properties appropriate to the kind of instruction.
`int` | `getInstructionNameCode()` Return the name of this instruction.
`Template` | `getTargetTemplate(XPathContext context)` Get the template, in the case where it is specified dynamically.
`java.util.Iterator` | `iterateSubExpressions()` Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)
`void` | `process(XPathContext context)` Process this instruction, without leaving any tail calls.
`TailCall` | `processLeavingTail(XPathContext context)` Process this instruction.
`protected void` | `promoteInst(PromotionOffer offer)` Handle promotion offers, that is, non-local tree rewrites.
`Expression` | `simplify(StaticContext env)` Simplify an expression.

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, assembleParams, assembleTunnelParams, computeCardinality, computeSpecialProperties, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, getImplementationMethod, getItemType, getSourceLocator, isXSLT, iterate, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, dynamicError, dynamicError, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### CallTemplate

    public CallTemplate(Template template,
                        WithParam[] actualParams,
                        WithParam[] tunnelParams,
                        boolean useTailRecursion,
                        Expression calledTemplateExpression,
                        NamespaceResolver nsContext)

  Construct a CallTemplate instruction.

Parameters:
  `template` - the Template object identifying the template to be called, in the normal case where this is known statically
  `actualParams` - array of WithParam instructions to calculate the actual parameters to be supplied to the call
  `calledTemplateExpression` - expression to calculate the name of the template to be called at run-time, this supports the saxon:allow-avt option
  `nsContext` - the static namespace context of the instruction, needed only in the case where the name of the called template is to be calculated dynamically

Method Detail

### getInstructionNameCode

    public int getInstructionNameCode()

  Return the name of this instruction.

  Overrides:
    `getInstructionNameCode` in class `Instruction`

### getInstructionInfo

    public InstructionInfo getInstructionInfo()

  Set additional trace properties appropriate to the kind of instruction. This implementation adds the template property, which identities the template to be called

  Specified by:
    `getInstructionInfo` in interface `InstructionInfoProvider`
  Overrides:
    `getInstructionInfo` in class `Instruction`

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression).

  Specified by:
    `simplify` in interface `Expression`
  Specified by:
    `simplify` in class `Instruction`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### analyze

    public Expression analyze(StaticContext env,
                              ItemType contextItemType)
                       throws XPathException

  Perform static analysis of an expression and its subexpressions.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables will only be accurately known if they have been explicitly declared.

  Specified by:
    `analyze` in interface `Expression`
  Specified by:
    `analyze` in class `Instruction`
  Parameters:
    `env` - the static context of the expression
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### createsNewNodes

    public final boolean createsNewNodes()

  Determine whether this instruction creates new nodes. This implementation currently returns true unconditionally.

  Overrides:
    `createsNewNodes` in class `Instruction`

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)

  Specified by:
    `iterateSubExpressions` in interface `Expression`
  Overrides:
    `iterateSubExpressions` in class `ComputedExpression`
  Returns:
    an iterator containing the sub-expressions of this expression

### promoteInst

    protected void promoteInst(PromotionOffer offer)
                        throws XPathException

  Handle promotion offers, that is, non-local tree rewrites.

  Overrides:
    `promoteInst` in class `Instruction`
  Parameters:
    `offer` - The type of rewrite being offered
  Throws:
    `XPathException`

### process

    public void process(XPathContext context)
                 throws XPathException

  Process this instruction, without leaving any tail calls.

  Specified by:
    `process` in interface `Expression`
  Overrides:
    `process` in class `Instruction`
  Parameters:
    `context` - the dynamic context for this transformation
  Throws:
    `XPathException` - if a dynamic error occurs

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Process this instruction. If the called template contains a tail call (which may be an xsl:call-template of xsl:apply-templates instruction) then the tail call will not actually be evaluated, but will be returned in a TailCall object for the caller to execute.

  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - the dynamic context for this transformation
  Returns:
    an object containing information about the tail call to be executed by the caller. Returns null if there is no tail call.
  Throws:
    `XPathException`

### getTargetTemplate

    public Template getTargetTemplate(XPathContext context)
                               throws XPathException

  Get the template, in the case where it is specified dynamically.

  Parameters:
    `context` - The dynamic context of the transformation
  Returns:
    The template to be called
  Throws:
    `XPathException` - if a dynamic error occurs: specifically, if the template name is computed at run-time (Saxon extension) and the name is invalid or does not reference a known template

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic print of expression structure. The expression is written to the System.err output stream

  Parameters:
    `level` - indentation level for this expression
    `out` -
    `pool` - NamePool used to expand any names appearing in the expression

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD